> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hasmcp.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Variable



## OpenAPI

````yaml post /variables
openapi: 3.0.4
info:
  title: HasMCP Manager API
  version: 1.0.0
  description: >-
    API for managing HasMCP components like Variables, Providers, MCP Servers,
    Resources, and Prompts.
servers: []
security:
  - bearerAuth: []
paths:
  /variables:
    post:
      summary: Create Variable
      operationId: createVariable
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateVariableRequest'
      responses:
        '201':
          description: Variable created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateVariableResponse'
      security:
        - oauth2:
            - variable:create
components:
  schemas:
    CreateVariableRequest:
      type: object
      properties:
        variable:
          $ref: '#/components/schemas/VariableCreate'
    CreateVariableResponse:
      type: object
      properties:
        variable:
          $ref: '#/components/schemas/Variable'
    VariableCreate:
      type: object
      properties:
        type:
          type: string
          description: '0: INVALID, 1: ENV, 2: SECRET'
          example: ENV
        value:
          type: string
          description: The variable's value.
        name:
          type: string
    Variable:
      type: object
      properties:
        id:
          type: string
          pattern: ^[A-Za-z0-9]{11}$
          example: kSuB9Gf6aD4
          readOnly: true
        createdAt:
          type: string
          format: date-time
          readOnly: true
        updatedAt:
          type: string
          format: date-time
          readOnly: true
        type:
          type: string
          description: '0: INVALID, 1: ENV, 2: SECRET'
          example: ENV
        value:
          type: string
          description: The variable's value. Will be '***' if type is SECRET on retrieval.
        name:
          type: string
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: >-
        Enter 'Bearer' followed by a space and your token (e.g., 'Bearer
        ${HASMCP_ACCESS_TOKEN}').
    oauth2:
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://accounts.hasmcp.com/oauth2/auth
          tokenUrl: https://accounts.hasmcp.com/oauth2/token
          scopes:
            gitconnection:list: List Git connections
            gitconnection:delete: Delete Git connection
            variable:list: List variables
            variable:create: Create variable
            variable:update: Update variable
            variable:delete: Delete variable
            provider:list: List providers
            provider:create: Create provider
            provider:read: Get provider
            provider:update: Update provider
            provider:delete: Delete provider
            server:list: List MCP servers
            server:create: Create MCP server
            server:read: Get MCP server
            server:update: Update MCP server
            server:delete: Delete MCP server
            server:create_token: Create MCP server token

````